Imports CPMotor_DotNET

Public Class Form1
    Dim Slot As Byte = 0
    Dim Baud As Byte = 5
    Dim Type As Byte = 1
    Dim Id As Byte = 1

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        combo_slot.SelectedIndex = 0
        combo_baud.SelectedIndex = 5
        combo_motortype.SelectedIndex = 1
        combo_motorid.SelectedIndex = 0

        Slot = 0
        Baud = 5
        Type = 1
        Id = 1
    End Sub

    Private Sub Form1_Closed(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Closed
        Dim ret As UInt16

        ret = CPMotor.CPMotor_MotionStop(Slot, Id, 300)
        If (ret <> 0) Then
            MessageBox.Show("CPMotor_MotionStop Error " + ret.ToString())
        Else
            ret = CPMotor.CPMotor_CloseMotor(Slot, Id)
            If (ret <> 0) Then
                MessageBox.Show("CPMotor_CloseMotor Error " + ret.ToString())
            Else
                ret = CPMotor.CPMotor_ShutdownMaster(Slot)
                If (ret <> 0) Then
                    MessageBox.Show("CPMotor_ShutdownMaster Error " + ret.ToString())
                End If
            End If
        End If
    End Sub

    Private Sub combo_slot_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles combo_slot.SelectedIndexChanged
        Slot = combo_slot.SelectedIndex
    End Sub

    Private Sub combo_baud_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles combo_baud.SelectedIndexChanged
        Baud = combo_baud.SelectedIndex
    End Sub

    Private Sub combo_motortype_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles combo_motortype.SelectedIndexChanged
        Type = combo_motortype.SelectedIndex
    End Sub

    Private Sub combo_motorid_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles combo_motorid.SelectedIndexChanged
        Id = (combo_motorid.SelectedIndex + 1)
    End Sub

    Private Sub bar_wpos_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bar_wpos.ValueChanged
        Dim ret As UInt16
        Dim tag_bar As Int32
        Dim tag_position As Int32, cur_position As Int32 = 0, delta_position As Int32

        ret = CPMotor.CPMotor_PP_CurrentPosition(Slot, Id, cur_position)
        If (ret <> 0) Then
            MessageBox.Show("CPMotor_PP_CurrentPosition Error " + ret.ToString())
            Return
        End If

        tag_bar = bar_wpos.Value
        If (tag_bar > 0) Then
            tag_position = ((tag_bar * 65536) - 1)
        Else
            tag_position = (tag_bar * 65536)
        End If

        text_wpos.Text = tag_position.ToString()

        delta_position = tag_position - cur_position
        ret = CPMotor.CPMotor_PP_MotionMove(Slot, Id, 1, 1, tag_position, Math.Abs(delta_position / 1000), Math.Abs(delta_position / 100), Math.Abs(delta_position / 1000))
        If (ret <> 0) Then
            MessageBox.Show("CPMotor_PP_MotionMove Error " + ret.ToString())
        End If
    End Sub

    Private Sub btn_initial_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_initial.Click
        Dim ret As UInt16

        ' CPMotor_InitMaster
        ret = CPMotor.CPMotor_InitMaster(CPMotor.MASTERMODULE.MASTER_MODULE_I8123W, Slot, Baud)
        If (ret <> 0) Then
            MessageBox.Show("CPMotor_InitMaster Error " + ret.ToString())
        Else
            ' CPMotor_AddMotor
            ret = CPMotor.CPMotor_AddMotor(Slot, Id, 1, 200, Type)
            If (ret <> 0) Then
                MessageBox.Show("CPMotor_AddMotor Error " + ret.ToString())
            Else
                ret = CPMotor.CPMotor_InitMotor(Slot, Id, 100)
                If (ret <> 0) Then
                    MessageBox.Show("CPMotor_InitMotor Error " + ret.ToString())
                Else
                    MessageBox.Show("AddMotor and InitMotor OK")

                    btn_initial.Enabled = False

                    combo_slot.Enabled = False
                    combo_baud.Enabled = False
                    combo_motorid.Enabled = False
                    combo_motortype.Enabled = False

                    bar_wpos.Enabled = True

                    timer1.Enabled = True
                End If
            End If
        End If
    End Sub

    Private Sub timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles timer1.Tick
        Dim ret As UInt16
        Dim position As Int32 = 0

        ret = CPMotor.CPMotor_PP_CurrentPosition(Slot, Id, position)
        If (ret = 0) Then
            text_rpos.Text = position.ToString()
            bar_rpos.Value = (position / 65536)
        End If
    End Sub

End Class
